---
layout: fr
title: "Curation of Getting to grips with Monero mini series"
author: Monero-Guides
date: November 16, 2021
amount: 12
milestones:
  - name: Importing public keys and verifying hashes
    funds:
    done:
    status: unfinished
  - name: Setting up a node
    funds: 5 XMR
    done:
    status: unfinished
  - name: Using Monero as money
    funds:
    done:
    status: unfinished
  - name: Using monero with enhanced privacy
    funds: 7 XMR
    done:
    status: unfinished
payouts:
  - date:
    amount:
  - date:
    amount:
---

## Preface 

Hi all,

After some careful consideration we've decided to put together a proposal for the CCS.
We now hope that this is the best method for garnering both community support and input.


### Getting to grips with Monero

We're here to pitch our first mini series. The working title for which is 'Getting to grips with Monero'

For those of you who are not familiar with our work, please check out our latest video, [Mining Monero with P2Pool - Windows; Quick start guide](https://www.youtube.com/watch?v=yfbvTksF9ic). We are really pleased with the reactions we've received and would love to capitalise on our current enthusiasm. 

The mini series/playlist we propose to curate will contain 4 videos, each of varying length and on different subjects.
They are: Importing public keys and verifying hashes, Setting up your own node, Using Monero as money and Using Monero with enhanced privacy.

We believe this series would be a great starter pack for anyone getting into monero and would help lift some more of the strain that still exists when on boarding new users. Let's summarise the contents of each video to illustrate.


## Video Contents

### Importing public keys and verifying hashes

First we plan on explaining a little bit about PGP, why its useful and its history and its links to cryptography.
That will be followed by an introduction to GPG, with step by step instructions for: creating your own key pair, importing someone else public key, signing their public key (brief explanation about web of trust) and using a public key to verify signatures.

Finally, an example of using that to verify sums and comparing those sums to those of the files we will download.

### Setting up a node

In this video, we want to both explain what a node is and their importance to the network and then show how to download and run the monero daemon.
Included will be basic explanations of: how to interact with the monero daemon, setting up your own config, the difference between a full and pruned node, locating the lmdb folder/changing and specifying its location.

We also want to discuss basic hardware recommendations for those who wish to keep there nodes running 24/7 

### Using Monero as money

Here we would like to show how to: create a wallet, show where wallet file is located and explain the difference between the different keys.

Following this would be demonstration of how to connect to a node from within a LAN and also how to connect to a remote node/hidden service in the case one cannot run their own.

Next: an explanation of how transactions are sent and how long they take (including locked funds), how to set up sub addresses (explain why they are useful/best practice).

We would like to finish the video by showing a practical example of how ask for and send funds (we want to show an IRL payment online @ https://digitalgoods.proxysto.re/), how to prove and verify proof you have sent or received funds and finish with a quick intro to payment ids/integrated addresses.

We will be demonstrating all of this with feather wallet due to its native tor integration, which will be required for the next video in the series. We will also show how to use Monerujo with tor for on-the-go payments.

### Using Monero with enhanced privacy

To begin this video we want to introduce the concept of coin control. Explain the implication of mixing inputs and hence the benefit of churning.

Next we want to explain how to connect to your own node from outside of your LAN. It will be necessary to explain how to forward ports on both your firewall and router and what the default ports are for RPCs.

Following this will be an explanation how to use your node in conjunction with a VPN and a brief overview of VPN itself. With our purchased VPN subscription from the 'using monero as money' video, we want to show how to forward ports on their service and how to change the default ports for those already discussed.

We also plan on showing how to set up a hidden service on Linux. Explaining its advantages for mobile use and how to use it with Feather Wallet and Monerujo.

## Additional comments 

Our scripts will be hosted on Github for review, prior to production - https://github.com/moneroguides and the completed videos will be initially hosted on Youtube.

Currently we already have two scripts awaiting comments.

We have also recently set up a website https://moneroguides.org where we will both mirror the videos from Youtube and host the texts for those who struggle with English as a second language.

Once all the texts have been completed and put into production. We would like to place bounties for their translation so that subtitles may be included.

## Milestones

We are proposing 4 milestones, one for each video. Each Milestone will be completed in sequential order. 'Payouts' are proposed after the release of the first two videos and upon completion. 

## What we are asking for

We want to work on this series part time for approximately 20 hours per week. It is planned for completion within 6 weeks after acceptance.

The amount we're asking for is reflected by a rate of $25/h. We have already raised ~1XMR via our [bounties propsoal](https://bounties.monero.social/posts/31/monero-guides-mini-series) which will be added if the proposal is accepted.

We are also hoping that competent members of the community step forward to help review and comment on our scripts! 

Thanks for taking the time to read this proposal and peace be with you privacy fans.
